Attribute VB_Name = "Module1"
Option Explicit

'// Declares
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'// Constants
Public Const WM_USER = &H400
Public Const CFM_BOLD = &H1
Public Const CFM_ITALIC = &H2
Public Const CFM_UNDERLINE = &H4
Public Const CFM_STRIKEOUT = &H8
Public Const CFM_SIZE = &H80000000
Public Const CFM_FACE = &H20000000
Public Const CFE_BOLD = &H1
Public Const CFE_ITALIC = &H2
Public Const CFE_UNDERLINE = &H4
Public Const CFE_STRIKEOUT = &H8
Public Const CFU_UNDERLINENONE = &H0
Public Const CFM_COLOR = &H40000000
Public Const LF_FACESIZE = 32
Public Const LF_FACESIZE2 = 64
Public Const EM_SETCHARFORMAT = (WM_USER + 68)
Public Const EM_GETCHARFORMAT = (WM_USER + 58)
Public Const SCF_ALL = &H4

'// Types
Type CHARFORMAT
    cbSize As Long
    dwMask As Long
    dwEffects As Long
    yHeight As Long
    yOffset As Long
    crTextColor As Long
    bCharSet As Byte
    bPitchAndFamily As Byte
    szFaceName(LF_FACESIZE) As Byte
End Type

'// ---------------------------------
'// ResetCharacterFormat Subroutine
'// ---------------------------------
'// Removes all formatting from the
'// specified rich text control w/o
'// needing to muck with SelStart and
'// SelLength etc. Reduces flickering
'// this way and doesn't modify scroll
'// position. Color is left intact,
'// but the syntax coloring feature
'// should take care of this.
'// ---------------------------------

Public Sub ResetCharacterFormat(TextObject As RichTextLib.RichTextBox)

  Dim udtCharFormat As CHARFORMAT         '// Structure to hold formatting info
  Dim objEmbedded   As RichTextLib.OLEObject
  
  '// Initialize the structure's size parameter
  '// which tells windows that we want a CHARFORMAT
  '// structure and not a CHARFORMAT2 structure.
  udtCharFormat.cbSize = LenB(udtCharFormat)

  '// Send a message to the rich text control to
  '// retrieve the DEFAULT (specified with 0&)
  '// formatting options. The default formatting
  '// options are specified at design time on the
  '// actual rich text control.
  SendMessage TextObject.hWnd, EM_GETCHARFORMAT, 0&, udtCharFormat

  '// Disable the resetting of color
  '// by clearing the CFM_COLOR flag.
  '// This is so we don't destroy our
  '// source code coloring feature.
  udtCharFormat.dwMask = udtCharFormat.dwMask And Not (CFM_COLOR)

  '// Post the DEFAULT structure back to the rich
  '// text control so that it strips all formatting
  '// (except color) from the contents.
  SendMessage TextObject.hWnd, EM_SETCHARFORMAT, SCF_ALL, udtCharFormat

  '// Also disallow OLE objects from being pasted
  '// in the editor...
  TextObject.OLEObjects.Clear
End Sub
' Remove all character formatting except color.
Public Sub ClearCharacterFormat(TextObject As RichTextLib.RichTextBox)
Dim udtCharFormat As CHARFORMAT    '// Structure to hold formatting info

    '// Initialize the structure's size parameter
    '// which tells windows that we want a CHARFORMAT
    '// structure and not a CHARFORMAT2 structure.
    udtCharFormat.cbSize = LenB(udtCharFormat)

    ' Define the attributes we will reset.
    udtCharFormat.dwMask = _
        CFM_BOLD Or _
        CFM_ITALIC Or _
        CFM_UNDERLINE Or _
        CFM_STRIKEOUT

    ' Set the attribute values.
    udtCharFormat.dwEffects = 0

    ' Set the attributes.
    SendMessage TextObject.hWnd, EM_SETCHARFORMAT, SCF_ALL, udtCharFormat
End Sub
